import { expect, tap } from '@pushrocks/tapbundle';
import { Qenv } from '@pushrocks/qenv';

import * as smartbucket from '../ts/index';

const testQenv = new Qenv('./', './.nogit/');

let testSmartbucket: smartbucket.SmartBucket;
let myBucket: smartbucket.Bucket;

tap.test('should create a valid smartbucket', async () => {
  testSmartbucket = new smartbucket.SmartBucket({
    accessKey: testQenv.getEnvVarOnDemand('S3_KEY'),
    accessSecret: testQenv.getEnvVarOnDemand('S3_SECRET'),
    endpoint: 'ams3.digitaloceanspaces.com'
  });
});

tap.skip.test('should create testbucket', async () => {
  await testSmartbucket.createBucket('smartbucket');
});

tap.skip.test('should remove testbucket', async () => {
  await testSmartbucket.removeBucket('pushrocks-smartbucket');
});

tap.test('should get a bucket', async () => {
  myBucket = await testSmartbucket.getBucketByName('smartbucket');
  expect(myBucket).to.be.instanceOf(smartbucket.Bucket);
  expect(myBucket.name).to.equal('smartbucket');
});

tap.test('should store data in bucket', async () => {
  myBucket.store
});

tap.start();
